clear all
clc
%function [curv_concrete_crushing_code]=curv_u_Paolo(B,H)

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% ++++++++++++++++++++++++    geometria sezione    ++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
section_type='rectangular'; % ---INPUT


N=-100; % ---INPUT

switch section_type
    case 'rectangular'
        B=300; % ---INPUT
        H=500; % ---INPUT
        dinf=41; % ---INPUT
        dsup=41; % ---INPUT
        dlat=41; % ---INPUT
        hut=H-dinf;
        
        fi_long=16; % ---INPUT
        Af(1)=800; % ---INPUT
        Af(2)=400; % ...
        Af(3)=400; % ...
        Af(4)=800; % ...
        
        for i=1:length(Af)
            % d_Af(i)=dsup+(hut-dsup)/(length(Af)-1)*(i-1); % rispetto al lembo superiore (dall'alto verso il basso)
            d_Af(i)=hut-(hut-dsup)/(length(Af)-1)*(i-1); % rispetto al lembo superiore (dal basso verso l'alto)
        end
    case 'circular'
        D=300;
        d=30;
        num_barre=12;
        db=12;
end

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% ++++++++++++++++++++++++    propriet ACCIAIO    ++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Es=210000.0; % ---INPUT
fy=500; % ---INPUT
epsy=fy/Es;
epssh=epsy; % ---INPUT
fsh=fy; % ---INPUT
epssu=0.10; % ---INPUT
fsu=fy*1.20; % ---INPUT
Esh=(fsu-fsh)/(epssu-epssh); % ---INPUT

% Es=210000.0; % ---INPUT
% fy=500; % ---INPUT
% epsy=fy/Es;
% epssh=0.02; % ---INPUT
% fsh=fy; % ---INPUT
% epssu=0.10; % ---INPUT
% fsu=fy*1.20; % ---INPUT
% Esh=0.02*Es; % ---INPUT

legame_acciaio='sigma_eps_steel_perfectly_plastic';
% legame_acciaio='sigma_eps_steel_hardening';
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% ++++++++++++++++++++++++      propriet CLS      ++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
epsco=0.002; % ---INPUT
fco=25; % ---INPUT
Ec=22000*(fco/10)^0.3;
fct=-1.2*0.30*(fco-8.0)^(2/3); % <0
epsct=fct/Ec; % <0

s=100; % ---INPUT
fi_stirrup=8; % ---INPUT
s_primo=s-fi_stirrup/2-fi_stirrup/2;
bc=B-dlat*2-fi_stirrup;
dc=H-dinf-dsup-fi_stirrup;
ro_cc=sum(Af)/(bc*dc);
w_primo=[bc/2-fi_long/2-fi_long/2
    bc/2-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    bc/2-fi_long/2-fi_long/2
    bc/2-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    dc/3-fi_long/2-fi_long/2
    ]; % ---INPUT
Ai=sum(w_primo.^2)/6;
Ae=(bc*dc-Ai)*(1-s_primo/(2*bc))*(1-s_primo/(2*dc));
ke=((1-Ai/(bc*dc))*(1-s_primo/(2*bc))*(1-s_primo/(2*dc)))/(1-ro_cc);
Asx=4*pi*fi_stirrup^2/4; % ---INPUT
Asy=3*pi*fi_stirrup^2/4; % ---INPUT
ro_x=Asx/(s*dc);
ro_y=Asy/(s*bc);
fyw=fy; % ---INPUT
fl_x_primo=ke*ro_x*fyw;
fl_y_primo=ke*ro_y*fyw;
fcc_x=fco*(-1.254+2.254*(1+7.94*fl_x_primo/fco)^0.5-2*fl_x_primo/fco);
fcc_y=fco*(-1.254+2.254*(1+7.94*fl_y_primo/fco)^0.5-2*fl_y_primo/fco);
fcc=0.5*(fcc_x+fcc_y);
epscc=epsco*(1+5*(fcc/fco-1));
Esec=fcc/epscc;
r=Ec/(Ec-Esec);

Eseco=fco/epsco;
ro=Ec/(Ec-Eseco);

Esp=Eseco*ro*(ro-1)*(1-2^ro)/(ro-1+2^ro)^2.0;
f_2epsco=(fco*2*ro)/(ro-1+2^ro);
epscsp=2*epsco-f_2epsco/Esp; % ---INPUT

% legame_cls='sigma_eps_concrete_par_rett';
legame_cls='sigma_eps_concrete_mander';




nfib=100; % ---INPUT






%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
switch section_type
    case 'rectangular'
        GEOM.B=B;
        GEOM.H=H;
        GEOM.hut=hut;
        GEOM.dsup=dsup;
        GEOM.dlat=dlat;
        d_Af_G=H/2-d_Af;
    case 'circular'
        Af=pi*(db/2)^2*ones(1,num_barre);
        d_Af=D/2+(D/2-d)*cos((0:(num_barre-1))*2*pi/num_barre); % rispetto al lembo superiore (in senso orario, a partire dalla barra posta al centro in basso)
        d_Af_G=D/2-d_Af;
        GEOM.D=D;
        GEOM.d=d;
        GEOM.num_barre=num_barre;
        GEOM.db=db;
end

GEOM.Af=Af;
GEOM.d_Af_G=d_Af_G;

CLS.fco=fco;
CLS.epsco=epsco;
CLS.fcc=fcc;
CLS.epscc=epscc;
CLS.Esec=Esec;
CLS.r=r;
CLS.Eseco=Eseco;
CLS.ro=ro;
CLS.epscsp=epscsp;
CLS.fct=fct;
CLS.epsct=epsct;
CLS.legame_cls=legame_cls;

GEOM.nfib=nfib;

% calcolo della distanza del baricentro di ogni fibra di cls dal baricentro
% geometrico della sezione e dell'area di ogni fibra
switch section_type
    case 'rectangular'
        dfib_G=H/2-H/nfib*(0.5+((1:nfib)-1));
        area_fib(1:nfib)=B*H/nfib;
    case 'circular'
        for i=1:nfib/2
            h=D/nfib*i;
            a=2*(h*(D-h))^0.5;
            theta=2*asin(a/D);
            area=(D/2)^2*acos((D/2-h)/(D/2))-(D/2-h)*(D*h-h^2)^0.5;
            y_G=(4*(D/2)*sin(theta/2)^3)/(3*(theta-sin(theta)));
            height_circular_segment(i)=h;
            chord_length_circular_segment(i)=a;
            theta_circular_segment(i)=theta;
            area_circular_segment(i)=area;
            y_G_circular_segment(i)=y_G;
        end
        dfib_G(1)=y_G_circular_segment(1);
        area_fib(1)=area_circular_segment(1);
        for i=2:nfib/2
            dfib_G(i)=(y_G_circular_segment(i)*area_circular_segment(i)-y_G_circular_segment(i-1)*area_circular_segment(i-1))/(area_circular_segment(i)-area_circular_segment(i-1));
            area_fib(i)=area_circular_segment(i)-area_circular_segment(i-1);
        end
        if nfib/2>floor(nfib/2)
            dfib_G(ceil(nfib/2))=0;
            area_fib(ceil(nfib/2))=2*(0.5*pi*(D/2)^2-area_circular_segment(floor(nfib/2)));
        end
        dfib_G(nfib:-1:nfib-floor(nfib/2)+1)=-dfib_G(1:floor(nfib/2));
        area_fib(nfib:-1:nfib-floor(nfib/2)+1)=area_fib(1:floor(nfib/2));
        %         dfib_G_approx=D/2-D/nfib*(0.5+((1:nfib)-1));
end
GEOM.dfib_G=dfib_G;
GEOM.area_fib=area_fib;

STEEL.Es=Es;
STEEL.epsy=epsy;
STEEL.fy=fy;
STEEL.epssh=epssh;
STEEL.Esh=Esh;
STEEL.epssu=epssu;
STEEL.fsu=fsu;
STEEL.fsh=fsh;
STEEL.legame_acciaio=legame_acciaio;
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------







% tollM=1/10^5;
tollN=1/10^5;






% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
switch section_type
    case 'rectangular'
        curv_ni_max_cr=(-epsct+epsco)/H;
        eps_G_ni_max_cr=epsct+curv_ni_max_cr*(H/2);
        curv=curv_ni_max_cr;
        eps_G=eps_G_ni_max_cr;
        [Msez,Nsez,LAST_CLS_ni_max_cr,LAST_STEEL_ni_max_cr] = MN_NEW (eps_G,curv,GEOM,CLS,STEEL,section_type);
        ni_max_cr=Nsez/(B*H*fco);
    case 'circular'
        curv_ni_max_cr=(-epsct+epsco)/D;
        eps_G_ni_max_cr=epsct+curv_ni_max_cr*(D/2);
        curv=curv_ni_max_cr;
        eps_G=eps_G_ni_max_cr;
        [Msez,Nsez,LAST_CLS_ni_max_cr,LAST_STEEL_ni_max_cr] = MN_NEW (eps_G,curv,GEOM,CLS,STEEL,section_type);
        ni_max_cr=Nsez/(pi*D^2/4*fco);
end
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

switch section_type
    case 'rectangular'
        curv_ni_max_y=(epsy+epsco)/hut;
        eps_G_ni_max_y=-epsy+curv_ni_max_y*(hut-H/2);
        curv=curv_ni_max_y;
        eps_G=eps_G_ni_max_y;
        [Msez,Nsez,LAST_CLS_ni_max_y,LAST_STEEL_ni_max_y] = MN_NEW (eps_G,curv,GEOM,CLS,STEEL,section_type);
        ni_max_y=Nsez/(B*H*fco);
    case 'circular'
        curv_ni_max_y=(epsy+epsco)/max(d_Af);
        eps_G_ni_max_y=-epsy+curv_ni_max_y*(max(d_Af)-D/2);
        curv=curv_ni_max_y;
        eps_G=eps_G_ni_max_y;
        [Msez,Nsez,LAST_CLS_ni_max_y,LAST_STEEL_ni_max_y] = MN_NEW (eps_G,curv,GEOM,CLS,STEEL,section_type);
        ni_max_y=Nsez/(pi*D^2/4*fco);
end

% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


tic


ni=N/(B*H*fco);

if ni<ni_max_cr
    fixed_eps=epsct;
    d_fixed_eps=H;
    [M_cr,eps_G_cr,curv_cr,LAST_CLS_cr,LAST_STEEL_cr] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);
else
    M_cr=0.0;
    curv_cr=0.0;
end

if ni<=ni_max_y
    fixed_eps=-epsy; % <0
    d_fixed_eps=hut;
    [M_y,eps_G_y,curv_y,LAST_CLS_y,LAST_STEEL_y] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);
else
    fixed_eps=epsco; % >0
    d_fixed_eps=0;
    [M_y_CLS,eps_G_y_CLS,curv_y_CLS,LAST_CLS_y_CLS,LAST_STEEL_y_CLS] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);
    curv_y=curv_y_CLS;
    M_y=M_y_CLS;
end

fixed_eps=epsco; % >0
d_fixed_eps=0;
[M_max_cover_concrete,eps_G_max_cover_concrete,curv_max_cover_concrete,LAST_CLS_max_cover_concrete,LAST_STEEL_max_cover_concrete] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);

if not(strcmp(legame_cls,'sigma_eps_concrete_par_rett'))
    fixed_eps=epscc; % >0
    d_fixed_eps=dsup;
    [M_max_core_concrete,eps_G_max_core_concrete,curv_max_core_concrete,LAST_CLS_max_core_concrete,LAST_STEEL_max_core_concrete] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);
    
    fixed_eps=epscsp; % >0
    d_fixed_eps=0;
    [M_spalling,eps_G_spalling,curv_spalling,LAST_CLS_spalling,LAST_STEEL_spalling] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);
end

fixed_eps=-epssu; % <0
d_fixed_eps=hut;
[M_steel_rupture,eps_G_steel_rupture,curv_steel_rupture,LAST_CLS_steel_rupture,LAST_STEEL_steel_rupture] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);

fixed_eps=0.0035; % >0
d_fixed_eps=0;
[M_concrete_crushing_code,eps_G_concrete_crushing_code,curv_concrete_crushing_code,LAST_CLS_concrete_crushing_code,LAST_STEEL_concrete_crushing_code] = fixed_strain_NEW (N,fixed_eps,d_fixed_eps,tollN,GEOM,CLS,STEEL,section_type);




% curv_array=[curv_cr curv_y:(curv_concrete_crushing_code-curv_y)/100:curv_concrete_crushing_code];
curv_array=[curv_cr curv_y:(curv_steel_rupture-curv_y)/100:curv_steel_rupture];




M_array=NaN(1,length(curv_array));
eps_G=0;
for i=1:length(curv_array);
    display(['analisi ', num2str(i), ' su ', num2str(length(curv_array))])
    [eps_G,M_array(i),Nsez,LAST_CLS,LAST_STEEL] = trasl_eps_G_NEW (curv_array(i),eps_G,N,tollN,GEOM,CLS,STEEL,section_type);
end
toc
[M_max,index_max]=max(M_array);
curv_max=curv_array(index_max);


results.ni=ni;

results.curv_ni_max_cr=curv_ni_max_cr;
results.ni_max_cr=ni_max_cr;

results.curv_ni_max_y=curv_ni_max_y;
results.ni_max_y=ni_max_y;

if ni<ni_max_cr
    results.M_cr=M_cr;   results.eps_G_cr=eps_G_cr;   results.curv_cr=curv_cr; results.LAST_CLS_cr=LAST_CLS_cr; results.LAST_STEEL_cr=LAST_STEEL_cr;
end

if ni<=ni_max_y
    results.M_y=M_y;   results.eps_G_y=eps_G_y;   results.curv_y=curv_y; results.LAST_CLS_y=LAST_CLS_y; results.LAST_STEEL_y=LAST_STEEL_y;
else
    results.M_y_CLS=M_y_CLS;   results.eps_G_y_CLS=eps_G_y_CLS;   results.curv_y_CLS=curv_y_CLS; results.LAST_CLS_y_CLS=LAST_CLS_y_CLS; results.LAST_STEEL_y_CLS=LAST_STEEL_y_CLS;
end

results.M_max=M_max;   results.curv_max=curv_max;

if not(strcmp(legame_cls,'sigma_eps_concrete_par_rett'))
    results.M_max_core_concrete=M_max_core_concrete;   results.eps_G_max_core_concrete=eps_G_max_core_concrete;   results.curv_max_core_concrete=curv_max_core_concrete; results.LAST_CLS_max_core_concrete=LAST_CLS_max_core_concrete; results.LAST_STEEL_max_core_concrete=LAST_STEEL_max_core_concrete;
    results.M_spalling=M_spalling;   results.eps_G_spalling=eps_G_spalling;   results.curv_spalling=curv_spalling; results.LAST_CLS_spalling=LAST_CLS_spalling; results.LAST_STEEL_spalling=LAST_STEEL_spalling;
end

results.M_steel_rupture=M_steel_rupture;   results.eps_G_steel_rupture=eps_G_steel_rupture;   results.curv_steel_rupture=curv_steel_rupture; results.LAST_CLS_steel_rupture=LAST_CLS_steel_rupture; results.LAST_STEEL_steel_rupture=LAST_STEEL_steel_rupture;

results.M_concrete_crushing_code=M_concrete_crushing_code;   results.eps_G_concrete_crushing_code=eps_G_concrete_crushing_code;   results.curv_concrete_crushing_code=curv_concrete_crushing_code; results.LAST_CLS_concrete_crushing_code=LAST_CLS_concrete_crushing_code; results.LAST_STEEL_concrete_crushing_code=LAST_STEEL_concrete_crushing_code;

results.M_max_cover_concrete=M_max_cover_concrete;   results.eps_G_max_cover_concrete=eps_G_max_cover_concrete;   results.curv_max_cover_concrete=curv_max_cover_concrete; results.LAST_CLS_max_cover_concrete=LAST_CLS_max_cover_concrete; results.LAST_STEEL_max_cover_concrete=LAST_STEEL_max_cover_concrete;
results.M_array=M_array;   results.curv_array=curv_array;




section_limit='y';
figure
eval(['plot(results.LAST_CLS_', section_limit, '(:,2),GEOM.dfib_G)']);
hold all
plot([0 0],[-GEOM.H/2 GEOM.H/2])
figure
eval(['plot(results.LAST_CLS_', section_limit, '(:,3),GEOM.dfib_G)']);
hold all
plot([0 0],[-GEOM.H/2 GEOM.H/2])




figure
plot([0 results.curv_array],[0 results.M_array],'LineStyle','-','Color',[0.9 0.9 0.9])