function [f,LAST] = sigma_eps_steel_hardening (eps,STEEL)


%INPUT -
%OUTPUT -


Es=STEEL.Es;
epsy=STEEL.epsy;
fy=STEEL.fy;
epssh=STEEL.epssh;
Esh=STEEL.Esh;
epssu=STEEL.epssu;
fsu=STEEL.fsu;
fsh=STEEL.fsh;


eps_sign=eps;
eps=abs(eps);

p_p=Esh*(epssu-epssh)/(fsu-fsh);

if eps<=epsy
    f=Es*eps;
elseif eps<=epssh
    f=fy+(eps-epsy)/(epssh-epsy)*(fsh-fy);
else
    if eps<epssu
        f=fsh+(fsu-fsh)*(1-(abs((epssu-eps)/(epssu-epssh)))^p_p);
    else
        f=fsu;
    end
end

if eps<=epsy
    Etg=Es;
elseif eps<=epssh
    Etg=(fsh-fy)/(epssh-epsy);
else
    if eps<epssu
        Etg=(epssu-eps)/abs(epssu-eps)*Esh*(abs((fsu-f)/(fsu-fsh)))^((p_p - 1)/p_p);
    else
        Etg=0;
    end
end

eps=eps_sign;
if eps_sign~=0
    f=f*eps_sign/abs(eps_sign);
end



if eps>0
    LAST(1)=1;
elseif eps==0
    LAST(1)=0;
elseif eps<0
    LAST(1)=2;
end
LAST(2)=eps;
LAST(3)=f;
LAST(4)=Etg;